﻿Public Class Form1
    Public Structure Employee
        Public ID As Integer
        <VBFixedString(15)> Public FirstName As String
        <VBFixedString(15)> Public LastName As String

        Public Sub New(ByVal new_id As Integer, ByVal first_name As String,
         ByVal last_name As String)
            ID = new_id
            FirstName = first_name
            LastName = last_name
        End Sub

        Public Overrides Function ToString() As String
            Return ID & ": " & FirstName & " " & LastName
        End Function
    End Structure

    Private Sub btnMakeRecords_Click() Handles btnMakeRecords.Click
        ' Declare a record variable.
        Dim emp As New Employee

        ' Get an available file number.
        Dim file_num As Integer = FreeFile()

        ' Open the file.
        FileOpen(file_num, "MYFILE.DAT", OpenMode.Random,
             OpenAccess.ReadWrite, OpenShare.Shared,
             Len(emp))

        ' Make some records.
        FilePut(file_num, New Employee(1, "Alice", "Altanta"))
        FilePut(file_num, New Employee(2, "Bob", "Bakersfield"))
        FilePut(file_num, New Employee(3, "Cindy", "Chicago"))
        FilePut(file_num, New Employee(4, "Dan", "Denver"))
        FilePut(file_num, New Employee(5, "Erma", "Eagle"))
        FilePut(file_num, New Employee(6, "Fred", "Frisco"))

        ' Fetch and display the records.
        Dim obj As ValueType = DirectCast(emp, ValueType)
        For Each i As Integer In New Integer() {3, 1, 5, 2, 6}
            FileGet(file_num, obj, i)
            emp = DirectCast(obj, Employee)
            Debug.WriteLine(emp.ToString())
        Next i

        ' Close the file.
        FileClose(file_num)

        MessageBox.Show("Done")
    End Sub
End Class
